//Computer Services
//Author: Ricardo Cantu

if (!csc) var csc = {};

if (!csc.engine)
{
  String.prototype.toBool = function () {
    return (/^(true|1)$/i).test(this);
  };

  // Now create the object
  csc.engine =  
  {
      prefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.engine.terminals."),
      idArray : ["a","b","c","d","e","f","g","h","i"],


      init: function()  {
        
        var platform,env,
        eng = csc.engine;
        
        // Put engine custom title
        try { document.getElementById("content").addEventListener("DOMTitleChanged", csc.engine.customTitle, false); } catch(e) {}

        env = Components.classes["@mozilla.org/process/environment;1"].getService(Components.interfaces.nsIEnvironment);

        platform = eng.getPlatform();
        if (platform == "win") {
          csc.computerName = env.get("COMPUTERNAME");
        }
        else if (platform == "nix") {
          csc.computerName = env.get("HOSTNAME");
        }
      },


      shutdown: function() {
        this.menu = null;
        this.prefs = null;
      },


      settings: function()  {
        window.openDialog("chrome://engine/content/settings.xul", "", "chrome,titlebar,toolbar,centerscreen,dialog=yes,resizable=yes");
      },


      customTitle: function() {

        /* Remove Mozilla and url from title bar */
        if (this.docShell.contentViewer)
        {
          if (this.contentDocument.title.substr(0,12) == "Smart System") {
            this.ownerDocument.title = this.contentDocument.title;
          }
        }
      },


      combineFileNameAndPath: function(fileName, filePath)  {

        var retVal = "";
        var platform = this.getPlatform();
        if (platform == "win")
        {
          retVal = filePath + "\\" + fileName;
        }
        else if (platform == "nix" || platform == "mac")
        {
          retVal = filePath + "//" + fileName;
        }

        return retVal;
      },


      addFileExtension: function(fileName) {

        var retVal = "";
        var platform = this.getPlatform();
        if (platform == "win")
        {
          if (!this.endsWith(fileName, ".lnk")) {
            retVal = fileName + ".lnk";
          }
        }
        else if (platform == "nix")
        {
          if (!this.endsWith(fileName,".desktop")) {
            retVal =  fileName + ".desktop";
          }
        } else if (platform == "mac")
        {
          if (!this.endsWith(fileName,".webloc")) {
            retVal =  fileName + ".webloc";
          }
        }

        return retVal;
      },


      endsWith: function(fileName, searchString) {

        var retVal = false;
        // does the searchString exist in filename
        var strPos = fileName.search(searchString);
        if (strPos != -1)
        {
          if (fileName.length == (strPos + searchString) )
          {
            retVal = true;
          }
        }

        return retVal;
      },


      fileExists: function(fileName, filePath) {

        var retVal = false;
        var fullPath = this.combineFileNameAndPath(fileName,filePath);

        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(fullPath);
        if (file.exists())
        {
          retVal = true;
        }
        return retVal;
      },


      showOK: function() {

        // Cause Linux and Mac do not show OK button
        var buttonAccept=document.documentElement.getButton('accept');
        buttonAccept.hidden = false;
        buttonAccept.disabled = false;
      },


      createShortcut: function(number) {

        try
        {
          var retVal = false;
          var platform = this.getPlatform();
          var deskTop = this.getDesktop();
          var extensionDir = this.getExtensionDir();
          var terminalObj = this.getTerminalObj(number);
          var fullFileName;

          var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

          if (terminalObj.conf != "smart") {
            fullFileName = this.combineFileNameAndPath("Smart System ("+terminalObj.id+") "+terminalObj.conf, deskTop);
          } else {
            fullFileName = this.combineFileNameAndPath("Smart System ("+terminalObj.id+")", deskTop);
          }

          fullFileName = this.addFileExtension(fullFileName);

          file.initWithPath(fullFileName);
          if (file.exists()) {
            file.remove(false);
          }

          if (platform == "win")
          {
            var programFiles = this.getProgramFiles();

            file.initWithPath(extensionDir+"\\components\\makelink.exe");

            var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
            process.init(file);

            var program = programFiles+"\\Mozilla Firefox\\firefox.exe";
            var arguments = "-chrome chrome://engine/content/engine.html?"+number;
            var linkfile = fullFileName;
            var description = "Smart System";
            var show = "1";
            var currentDirectory = programFiles+"\\Mozilla Firefox";
            var icon = extensionDir+"\\chrome\\skin\\images\\csc.ico";
            var iconIndex = "0";

            var args = [program,arguments,linkfile,description,show,currentDirectory,icon,iconIndex];
            process.run(false, args, args.length);
          }
          else
          {
            // Linux and Mac

            file.create(0x00, 0755);
            var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
            createInstance(Components.interfaces.nsIFileOutputStream);

            outputStream.init(file, 0x20 | 0x02, 00004,null);
            var converterOutputStream = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
            createInstance(Components.interfaces.nsIConverterOutputStream);

            converterOutputStream.init(outputStream, "UTF-8", 0, 0x0000);

            var outString = "";

            if (platform == "nix")
            {
              outString = "[Desktop Entry]\n"+
              "Version=1.0\n"+
              "Encoding=UTF-8\n"+
              "Name=Smart System ("+terminalObj.id+")\n"+
              "GenericName=Smart System\n"+
              "Comment=Browse the Web\n"+
              "Exec=firefox -chrome chrome://engine/content/engine.html?"+number+"\n"+
              "Icon="+extensionDir+"/chrome/skin/images/csc.png\n"+
              "Terminal=false\n"+
              "Type=Application\n"+
              "StartupWMClass=Firefox-bin\n"+
              "MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;\n"+
              "StartupNotify=true\n"+
              "X-Desktop-File-Install-Version=0.15\n"+
              "Categories=Network;WebBrowser;\n";
            }
            else if (platform == "mac")
            {
              outString = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n"+
              "<!DOCTYPE plist PUBLIC \"-//Apple//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\r\n"+
              "<plist version=\"1.0\">\r\n"+
              "<dict>\r\n"+
              "\t<key>URL</key>\r\n"+
              "\t<string>"+
              "chrome://engine/content/engine.html?"+number+
              "</string>\r\n"+
              "</dict>\r\n"+
              "</plist>\r\n";
            }

            converterOutputStream.writeString(outString);
            converterOutputStream.close();
          }

          retVal = true;
        }
        catch (ex)
        {
          alert('Error in createShortcut: '+ex);
          retVal = false;
        }

        return retVal;
      },


      removeShortcut: function(number) {

        var fullFileName;

        try
        {
          var retVal = false;
          var deskTop = this.getDesktop();
          var terminalObj = this.getTerminalObj(number);

          var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

          if (terminalObj.conf != "smart") {
            fullFileName = this.combineFileNameAndPath("Smart System ("+terminalObj.id+")"+terminalObj.conf, deskTop);
          } else {
            fullFileName = this.combineFileNameAndPath("Smart System ("+terminalObj.id+")", deskTop);
          }
          fullFileName = this.addFileExtension(fullFileName);

          file.initWithPath(fullFileName);
          if (file.exists()) {
            file.remove(false);
          }

          retVal = true;
        }
        catch (ex)
        {
          alert('Bad things happened: '+ex);
          retVal = false;
        }

        return retVal;
      },


      getPlatform: function()
      {
        // currently supported
        // "WINNT"
        // "Linux"
        // "Darwin"
        //
        var retVal = "unk";
        var osVal = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS.toLowerCase();
        var platVal = navigator.platform.toLowerCase();

        if (osVal == "winnt" || platVal == "win32" || platVal == "windows")
        {
          retVal = "win";
        }
        else if (osVal == "darwin" || platVal == "mac68k" || platVal == "macppc" || platVal == "macintosh")
        {
          retVal = "mac";
        }
        else if (osVal = "linux" || osVal == "freebsd" || osVal == "openbsd" || osVal == "netbsd" || osVal == "sunos" || platVal == "x11")
        {
          retVal = "nix";
        }
        return retVal;
      },


      getOS: function()
      {
        var retVal = "unk";
        var platForm = this.getPlatform();
        var ua = navigator.userAgent.toLowerCase();

        if (platForm == "win")
        {
          if (ua.indexOf("win95") > -1 || ua.indexOf("windows 95") > -1)
          {
            retVal = "w95";
          }
          else if (ua.indexOf("win98") > -1 || ua.indexOf("windows 98") > -1)
          {
            retVal = "w98";
          }
          else if (ua.indexOf("win 9x 4.90") > -1|| ua.indexOf("windows me") > -1)
          {
            retVal = "wme";
          }
          else if (ua.indexOf("winnt") > -1 || ua.indexOf("windows nt") > -1 || ua.indexOf("winnt4.0") > -1 || ua.indexOf("windows nt 4.0") > -1)
          {
            retVal = "wnt";
          }
          else if (ua.indexOf("windows nt 5.0") > -1|| ua.indexOf("windows 2000") > -1)
          {
            retVal = "w2k";
          }
          else if (ua.indexOf("windows nt 5.1") > -1 || ua.indexOf("windows xp") > -1)
          {
            retVal = "wxp";
          }
          else if (ua.indexOf("windows nt 6.0") > -1)
          {
            retVal = "vis";
          }

        }
        else if (platForm == "mac")
        {
          if(navigator.plugins["Default Plugin Carbon.cfm"] || ua.indexOf("omniweb") != -1 || ua.indexOf('os x') != -1)
          {
            retVal = "osx";
          }
          else if (ua.indexOf("mac_68000") > -1 || ua.indexOf("68k") > -1)
          {
            retVal = "68k";
          }
          else if (ua.indexOf("mac_powerpc") > -1 || ua.indexOf("ppc") > -1 )
          {
            retVal = "ppc";
          }

        }
        else if (platForm == "nix")
        {
          if (osVal = "linux")
          {
            retVal = "lin";
          }
          else if (osVal == "freebsd" || osVal == "openbsd" || osVal == "netbsd")
          {
            retVal = "bsd";
          }
          else if (osVal == "sunos")
          {
            retVal = "sun";
          }
        }

        return retVal;
      },


      pad: function(val, len) 
      {
        val = String(val);
        len = len || 2;

        while (val.length < len)  {
          val = "0" + val;
        }
        return val;
      },


      getTerminalObj: function(number) {

        var prefsValue = csc.engine.prefs.getCharPref(number);
        if (!prefsValue) return;

        var terminalObj = prefsValue.split(",");

        terminalObj.id = terminalObj[0];
        terminalObj.ip = terminalObj[1];
        if (terminalObj[2] == "" || terminalObj[2] == " ") {
          terminalObj.conf = "smart";
        }
        else {
          terminalObj.conf = terminalObj[2];
        }

        return terminalObj;
      },


      getExtensionDir: function() {
        var dir = this.getDirService("ProfD");
        if (dir)
        {
          dir.append("extensions");
          dir.append("engine@smartcsc.com");
          return dir.path;
        }
        alert("Extensions path not found");
      },

      getDesktop: function() {
        var dir = this.getDirService("Desk");
        if (dir) {
          return dir.path;
        }
        alert("Desktop path not found");
      },

      getProgramFiles: function() {
        var dir = this.getDirService("ProgF");
        if (dir) {
          return dir.path;
        }
        alert("Program Files path not found");
      },

      getDirService: function(key) {
        var retVal = '';
        var dirService = Components.classes['@mozilla.org/file/directory_service;1']
        .getService(Components.interfaces.nsIProperties);
        var dir = dirService.get(key, Components.interfaces.nsIFile);
        if (dir.exists()) {
          retVal = dir;
        }
        return retVal;
      },

      webPage : {

        recvMsg : function(e) {

          //Firebug.Console.log("csc.engine.webPage.recvMsg: "+e.target.getAttribute("messageType"));

          var element = e.target,
          type = element.getAttribute("messageType"),
          webPage = csc.engine.webPage;

          switch (type)
          {
          case "tabs":
            webPage.tabs(element);
            break;

          case "clipBoard":
            webPage.clipBoard(element);
            break;

          default:
            webPage.msgReturn(element, 1, "Invalid message type: "+type);
          break;
          }
        },


        sendMsg : function (msgElement) {

          //Firebug.Console.log("csc.engine.webPage.sendMsg");

          var event = document.createEvent("Event");

          event.initEvent("webPageMessage", true, true);
          msgElement.dispatchEvent(event);
        },


        msgReturn : function(msgElement, status, statusString) {

          //Firebug.Console.log("csc.engine.webPage.msgReturn: ("+status+") "+statusString);

          msgElement.setAttribute("originalType", msgElement.getAttribute("messageType"));
          msgElement.setAttribute("messageType", "messageReturn");
          msgElement.setAttribute("status", status);
          msgElement.setAttribute("statusString", statusString);

          csc.engine.webPage.sendMsg(msgElement);
        },


        tabs : function(element) {

          //Firebug.Console.log("csc.engine.webPage.tabs");

          var fKey,switchTab,x,mTabContainer,tabIndex,terminalId,newTerminalId,newSearch,
          firstTabLocation,numberOfTabs,firstNumber,letterIndex,gBrowser,
          letterIndex2,letterGroup,letter,letter2,secondDigit,
          eng = csc.engine,
          letterArray = [["a","b","c","d","e","f","g","h","i"],
                         ["j","k","l","m","n","o","p","q","r"],
                         ["s","t","u","v","w","x","y","z","z"]];

          fKey = element.getAttribute("fKey");
          switchTab = element.getAttribute("switchTab").toBool();

          gBrowser = eng.getWindowByLocation(element.ownerDocument.location);
          mTabContainer = gBrowser.mTabContainer;
          tabIndex = fKey - 112;
          numberOfTabs = mTabContainer.childNodes.length;

          if ((tabIndex+1) > numberOfTabs)
          {
            firstTabLocation = mTabContainer.childNodes[0].linkedBrowser.contentWindow.location;
            terminalId = firstTabLocation.search.substr(firstTabLocation.search.indexOf("ENG_ID=") + 7, 2);
            secondDigit = terminalId.substr(1,1);

            firstNumber = parseInt(terminalId.substr(0,1), 10);
            
            if (!firstNumber) {
              alert("Close window and re-open to activate alternate");
              return;
            }
            
            secondNumber = parseInt(secondDigit, 10);
            
            if (isNaN(secondNumber)) {
              newTerminalId = firstNumber + String.fromCharCode(secondDigit.charCodeAt() + tabIndex);
            }
            else
            {
              letterIndex = firstNumber - 1;
              letterIndex2 = secondNumber;
              letterGroup = Math.floor(numberOfTabs / 4);
              letter = letterArray[letterGroup][letterIndex];
              letter2 = letterArray[0][letterIndex2];
  
              if (numberOfTabs == 1 || numberOfTabs == 4 || numberOfTabs == 8) {
                newTerminalId = letter + secondNumber + "";
              }
              else 
              {
                x = numberOfTabs;
  
                if (x > 8) {
                  x -= 7;
                }
                else if (x > 4) {
                  x -= 3;
                }
  
                switch(x)
                {
                case 2:
                  newTerminalId = secondNumber + letter + "";
                  break;
                case 3:
                  newTerminalId = letter + letter2 + "";
                  break;
                case 4:
                  newTerminalId = letter2 + letter + "";
                  break;
                default:
                  newTerminalId = "XX";
                break;
                } 
              }
            }

            newSearch = firstTabLocation.search.replace("ENG_ID="+terminalId, "ENG_ID="+newTerminalId);
            newSearch = newSearch.replace(/&ENG_ALTS=[0-9]*/, "");
            gBrowser.addTab("http://"+firstTabLocation.hostname+"/engine.html"+newSearch);
          }

          if (switchTab) {
            mTabContainer.selectedIndex = tabIndex;
          }

          eng.webPage.msgReturn(element, 0, "OK");
        },



        clipBoard : function(element) {

          //Firebug.Console.log("csc.engine.webPage.clipBoard");

          var clip, trans, str, strLength, action,
          webPage = csc.engine.webPage;

          action = element.getAttribute("action");

          switch(action)
          {

          case "get":

            clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard),
            trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);

            if (!clip || !trans) 
            {
              webPage.msgReturn(element, 1, "clipBoard: clip or trans not available.");
              return;
            }

            trans.addDataFlavor("text/unicode");
            clip.getData(trans, clip.kGlobalClipboard);

            str = new Object();
            strLength = new Object();

            trans.getTransferData("text/unicode", str, strLength);

            if (str) {
              str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
            }

            if (str) 
            {
              element.setAttribute("clipString", str.data.substring(0, strLength.value / 2));
              webPage.sendMsg(element);
              return;
            }

            webPage.msgReturn(element, 0, "OK");

            return;
          }
        }
      },



      getWindowByLocation : function (location) {

        //Firebug.Console.log("csc.engine.getWindowByLocation: "+location);

        var i,wm,browserEnumerator,gBrowser,mTabContainer,numberOfTabs;

        wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);

        browserEnumerator = wm.getEnumerator("navigator:browser");
        while (browserEnumerator.hasMoreElements()) 
        {
          gBrowser = browserEnumerator.getNext().gBrowser;
          mTabContainer = gBrowser.mTabContainer;
          numberOfTabs = mTabContainer.childNodes.length;

          for (i=numberOfTabs-1; i >= 0; i--)
          {
            if (mTabContainer.childNodes[i].linkedBrowser.contentWindow.location == location) {
              return(gBrowser);
            }
          }
        }

        return(null);
      }

  };
}


//Install load and unload handlers:
window.addEventListener("load", csc.engine.init, false);
window.addEventListener("unload", csc.engine.shutdown, false);
document.addEventListener("extensionMessage", csc.engine.webPage.recvMsg, false, true);
