var settings = {
  terminals: [],

  connectionWizard: function() {

    var prefs = Cc["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefService)
    .getBranch("extensions.engine.terminals.");
    
    var result;
    var id;
    var ip;
    var conf;
    
    while (true)  {
      result = settings.prompt(GetString('wizard.title'),GetString('wizard.id'),"");
      if (!result) { return; };
      if (result.value.length == 2) {
        break;
      }
      alert(GetString('wizard.id.error'));
    }
    id = result.value;
    
    result = settings.prompt(GetString('wizard.title'),GetString('wizard.ip'),"");
    if (!result) { return; };
    ip = result.value;
    
    result = settings.prompt(GetString('wizard.title'),GetString('wizard.conf'),"smart");
    if (!result) { return; };
    conf = result.value;

    var branch = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.engine.terminals.");
    var children = branch.getChildList("", {});
    var number = children.length;
    
    var terminalRecord = id+","+ip+","+conf;
    prefs.setCharPref(number, terminalRecord);
    settings.addTerminal(number);
  },
  
  prompt: function(title, text, value) {

    var prompts = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var check = {value: false};                  // default the checkbox to false
    var input = {value: ""};                     // default the edit field to blanks

    if (value) {
      input.value = value;
    }

    var result = prompts.prompt(null, title, text, input, null, check);
    
    // result is true if OK is pressed, false if Cancel. input.value holds the value of the edit field if "OK" was pressed.
    if (!result) { return null; }
    input.check = check.value;
    return(input);
    
  },

  addTerminal: function(number) {
    
    var prefsValue = csc.engine.prefs.getCharPref(number);
    var terminalObj = prefsValue.split(",");
    
    var pref = document.createElement("preference");
    pref.setAttribute("id", "extensions.engine.terminals." + number);
    pref.setAttribute("name", "extensions.engine.terminals." + number);
    pref.setAttribute("type", "string");
    $("pane_connections").getElementsByTagName("preferences")[0].appendChild(pref);
    
    var row = document.createElement("row");
    row.setAttribute("align", "center");
    
    var label = document.createElement("label");
    label.setAttribute("value", "Terminal: "+terminalObj[0]+"   Server: "+terminalObj[1]+"   Config: "+terminalObj[2]);
    
    var remove = document.createElement("button");
    remove.setAttribute("label", GetString("remove"));
    
    row.appendChild(label);
    row.appendChild(remove);
    $("connection_rows").appendChild(row);
    
    settings.terminals.push({
      remove: remove,
      row: row,
      pref: pref
    });

    csc.engine.createShortcut(number);
    
    Events.add(remove, "command", settings.removeTerminal);
  },

  removeTerminal: function(e) {
    
    var index = -1;
    for (var i=0;i<settings.terminals.length;i++) {
      var terminal = settings.terminals[i];
      if (terminal.remove == e.target) { index = i; }
    }
    if (index == -1) { throw new Error("Cannot remove terminal " + e.target); }

    var terminal = settings.terminals[index];
    settings.terminals.splice(index, 1);
    var name = terminal.pref.name;
    terminal.pref.parentNode.removeChild(terminal.pref);
    terminal.row.parentNode.removeChild(terminal.row);

    csc.engine.removeShortcut(index);
    
    var branch = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("");
    branch.clearUserPref(name);
  },

  init: function(e) {
    Events.add($("connection_add"), "command", settings.connectionWizard);

    var branch = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.engine.terminals.");
    var children = branch.getChildList("", {});
    children.forEach(settings.addTerminal);

    window.focus();
  }
};

Events.add(window, "load", settings.init);
Events.add(window, "unload", Events.clear.bind(Events));
